/*
 * Copyright (C) 2012 Red Hat, Inc.  All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Authors: Radek Novacek <rnovacek@redhat.com>
 */

#ifndef SETTING_PRIVATE_H
#define SETTING_PRIVATE_H

#include "setting.h"
#include "ipconfig.h"

struct Setting
{
    /// Type of the setting (IPv4, IPv6, Wired, Bond, Bridge etc.)
    SettingType type;
    /// Identification on setting
    char *id;
    /// User readable caption
    char *caption;
    // Type-specific data
    union {
        IPConfig ip;
        struct {
            char *interface_name;
            char *options;
        } bond;
        struct {
            char *interface_name;
            bool stp;
            unsigned int priority;
            unsigned int forward_delay;
            unsigned int hello_time;
            unsigned int max_age;
            unsigned int ageing_time;
        } bridge;
        struct {
            char *mac;
        } wired;
    } typespec;
};

#endif
